# Copyright (C) 2020 Bloomberg LP
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#  <http://www.apache.org/licenses/LICENSE-2.0>
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""Add inline blob support

Revision ID: 53e8b8b5bed6
Revises: c64c104b2c8b
Create Date: 2022-05-19 14:58:32.569388

"""
import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision = "53e8b8b5bed6"
down_revision = "c64c104b2c8b"
branch_labels = None
depends_on = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column("index", sa.Column("inline_blob", sa.LargeBinary(), nullable=True))
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column("index", "inline_blob")
    # ### end Alembic commands ###
